<HTML>
<HEAD>
  <META NAME="GENERATOR" CONTENT="Adobe PageMill 3.0 Win">
  <TITLE>Using CVS</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff">

<H2>Checking out the project using CVS</H2>

<P>There is documentation for CVS at <TT><A HREF="http://www.cyclic.com/">http://www.cyclic.com</A></TT>
and <TT><A HREF="http://www.loria.fr/~molli/cvs-index.html">http://www.loria.fr/~molli/cvs-index.html</A></TT>.</P>

<P>There is also a <A HREF="cvs.ps">PostScript document</A>.</P>

<P>Generally speaking, CVS is a <I>version control system</I>
that allows multiple people to work on the same project simultaneously.
Each user gets a personal copy of the entire source tree. CVS
is used to:</P>

<UL>
  <LI><I>Check out</I> the source tree,
  <LI><I>Commit</I> changes that were made to the local copy,
  <LI><I>Update</I> the local copy with any changes that were commited
  by other users.
</UL>

<H2>Getting started (<I><TT>cvs checkout</TT></I>)</H2>

<P>To get started, you need an account on the Caltech CS machines,
since that is where the central database is stored. You also need
to be in the Unix <TT>cs237-proj</TT> group to have permission
to access the database. Send mail to <TT><A HREF="mailto:jyh@cs.caltech.edu">jyh@cs.caltech.edu</A></TT>
if that is a problem.</P>

<P>To check out your personal copy, go to the place where you
want to put the source code. This step will create a directory
called <B><TT>ambient</TT></B> with all the source code in it.
Then execute the following command from the Unix prompt:</P>

<BLOCKQUOTE>
  <P><TT>cvs -d /ufs/students5/cs237/cvs checkout ambient</TT></P>
</BLOCKQUOTE>

<P>This will print a message for each source file that is created.
Each subdirectory contains a <B><TT>CVS</TT></B> directory that
contains system info for CVS. <B>Don't mess with the files in
the <TT>CVS</TT> directories!</B></P>

<P>If you want to use a machine outside of Caltech CS (like at
home), you can use <B><TT>ssh</TT></B>. Pick a machine to act
as your central server, like <TT>stravinsky</TT>. The line break
on the <TT>cvs</TT> line doesn't really exist; its there so you
can read the line.</P>

<BLOCKQUOTE>
  <PRE><TT>% setenv CVS_RSH ssh</TT>
<TT>% cvs -d :ext:stravinsky.cs.caltech.edu:/ufs/</TT>
<TT>students5/cs237/cvs checkout ambient</TT></PRE>
</BLOCKQUOTE>

<H2>Incorporating changes from the master database (<I><TT>cvs
update</TT></I>)</H2>

<P>There are times when you will want to incorporate changes others
have made to the master source code. For instance, when something
actually gets implemented. To do this, run the following command
in the <TT>ambient</TT> directory:</P>

<BLOCKQUOTE>
  <P><TT>% cvs update</TT></P>
</BLOCKQUOTE>

<P>This will print out a bunch of messages, one for each file
that gets updated. The changes are automatically merged with any
changes you have made. <B>Beware of comflicts!</B> If you have
made changes to the same lines of code as someone else, CVS will
not know how to do the merge. IT will print out a line starting
with a <TT>C</TT>, and the file will be updated with the conflicts
marked like this:</P>

<UL>
  <DL>
    <DT><TT>&lt;&lt;&lt;&lt;&lt;&lt;</TT>
    <DT><I>Updated version</I>
    <DT><TT>======</TT>
    <DT><I>Your version</I>
    <DT><TT>&gt;&gt;&gt;&gt;&gt;&gt;&gt;</TT>
  </DL>
</UL>

<P>You have to fix these conflicts by hand.</P>

<H2>Commiting your changes (<I><TT>cvs commit</TT></I>)</H2>

<P>Now you can modify the files on the compiler as you wish. When
you are finished making your changes, and you want to commit your
changes to the master copy, use the following command from the
<TT>ambient</TT> directory.</P>

<BLOCKQUOTE>
  <P><TT>% cvs commit</TT></P>
</BLOCKQUOTE>

<P>This pops up an editor window where you should type in a message
describing your changes. <B>Make sure you describe your changes!</B>
It can be something simple like: <I>Modified continuation-passing
code in fir</I>.</P>

<P>You can't commit your changes if your copy of the code is out-of-date
with respect to the master copy. In this case, CVS will complain,
and not let you commit. In this case, do a <TT>cvs update</TT>
first. <B>Make sure your code compiles before you commit!</B>
Often the code will not compile after a <TT>cvs update</TT>, so
check it and make sure.</P>

<H2>Adding files (<I><TT>cvs add</TT></I>)</H2>

<P>You can add new files and directories with <TT>cvs add</TT>
like this:</P>

<BLOCKQUOTE>
  <P><TT>% cvs add junk.ml<BR>
  % cvs add junk_dir</TT></P>
</BLOCKQUOTE>

<H2>Removing files (<I><TT>cvs remove</TT></I>)</H2>

<P>You can remove files that are no longer needed with <TT>cvs
remove</TT>. You have to <TT>rm</TT> the file first.</P>

<BLOCKQUOTE>
  <P><TT>% rm junk.ml<BR>
  % cvs remove junk.ml</TT></BLOCKQUOTE>

</BODY>
</HTML>
